package org.hibernate.service.spi;

import org.hibernate.cfg.Configuration;
import org.hibernate.engine.spi.SessionFactoryImplementor;
import org.hibernate.metamodel.source.MetadataImplementor;
import org.hibernate.service.Service;

public interface SessionFactoryServiceRegistryFactory2  extends Service {
	/**
	 * Create the registry.
	 *
	 * @todo : fully expect this signature to change!
	 *
	 * @param sessionFactory The (in flux) session factory.  Generally this is useful for grabbing a reference for later
	 * 		use.  However, care should be taken when invoking on the session factory until after it has been fully
	 * 		initialized.
	 * @param configuration The configuration object.
	 *
	 * @return The registry
	 */
	public SessionFactoryServiceRegistry buildServiceRegistry(
			SessionFactoryImplementor sessionFactory,
			Configuration configuration);

	/**
	 * Create the registry.
	 *
	 * @todo : fully expect this signature to change!
	 *
	 * @param sessionFactory The (in flux) session factory.  Generally this is useful for grabbing a reference for later
	 * 		use.  However, care should be taken when invoking on the session factory until after it has been fully
	 * 		initialized.
	 * @param metadata The configuration object.
	 *
	 * @return The registry
	 */
	public SessionFactoryServiceRegistry buildServiceRegistry(
			SessionFactoryImplementor sessionFactory,
			MetadataImplementor metadata);

}
