package org.hibernate.event.service.internal;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.hibernate.engine.spi.CacheInitiator;
import org.hibernate.service.spi.SessionFactoryServiceInitiator;
import org.hibernate.stat.internal.StatisticsInitiator;

public class StandardSessionFactoryServiceInitiators2 {
	public static List<SessionFactoryServiceInitiator> LIST = buildStandardServiceInitiatorList();

	private static List<SessionFactoryServiceInitiator> buildStandardServiceInitiatorList() {
		final List<SessionFactoryServiceInitiator> serviceInitiators = new ArrayList<SessionFactoryServiceInitiator>();

		serviceInitiators.add( EventListenerServiceInitiator2.INSTANCE );
		serviceInitiators.add( StatisticsInitiator.INSTANCE );
		serviceInitiators.add( CacheInitiator.INSTANCE );

		return Collections.unmodifiableList( serviceInitiators );
	}
}
